Ipopt 3.12.10

- Main Page
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

All Classes Namespaces Files Functions Variables Typedefs Enumerations Enumerator Friends Macros
Public Member Functions | Private Attributes | List of all members
Ipopt::ExpandedMultiVectorMatrix Class Reference

Class for Matrices with few rows that consists of Vectors, together with a premultiplied Expansion matrix. More...

`#include <IpExpandedMultiVectorMatrix.hpp>`

Inheritance diagram for Ipopt::ExpandedMultiVectorMatrix:
[legend]

## Public Member Functions
SmartPtr < ExpandedMultiVectorMatrix > | MakeNewExpandedMultiVectorMatrix () const
void | SetVector (Index i, SmartPtr< const Vector > vec)
| Set a particular Vector at a given row position, replacing another vector if there has been one. More...
SmartPtr< const Vector > | GetVector (Index i) const
| Get a Vector in a particular row as a const Vector. More...
SmartPtr< const VectorSpace > | RowVectorSpace () const
| Vector space for the rows. More...
SmartPtr< const ExpandedMultiVectorMatrixSpace > | ExpandedMultiVectorMatrixOwnerSpace () const
| Return the ExpandedMultiVectorMatrixSpace. More...
SmartPtr< const ExpansionMatrix > | GetExpansionMatrix () const
| Return the Expansion matrix. More...
Constructors / Destructors
| ExpandedMultiVectorMatrix (const ExpandedMultiVectorMatrixSpace *owner_space)
| Constructor, taking the owner_space. More...
virtual | ~ExpandedMultiVectorMatrix ()
| Destructor. More...
Public Member Functions inherited from Ipopt::Matrix
bool | HasValidNumbers () const
| Method for determining if all stored numbers are valid (i.e., no Inf or Nan). More...
SmartPtr< const MatrixSpace > | OwnerSpace () const
| Return the owner MatrixSpace. More...
| Matrix (const MatrixSpace *owner_space)
| Constructor. More...
virtual | ~Matrix ()
| Destructor. More...
void | MultVector (Number alpha, const Vector &x, Number beta, Vector &y) const
| Matrix-vector multiply. More...
void | TransMultVector (Number alpha, const Vector &x, Number beta, Vector &y) const
| Matrix(transpose) vector multiply. More...
void | AddMSinvZ (Number alpha, const Vector &S, const Vector &Z, Vector &X) const
| X = X + alpha*(Matrix S^{-1} Z). More...
void | SinvBlrmZMTdBr (Number alpha, const Vector &S, const Vector &R, const Vector &Z, const Vector &D, Vector &X) const
| X = S^{-1} (r + alpha*Z*M^Td). More...
Index | NRows () const
| Number of rows. More...
Index | NCols () const
| Number of columns. More...
void | ComputeRowAMax (Vector &rows_norms, bool init=true) const
| Compute the max-norm of the rows in the matrix. More...
void | ComputeColAMax (Vector &cols_norms, bool init=true) const
| Compute the max-norm of the columns in the matrix. More...
virtual void | Print (SmartPtr< const Journalist > jnlst, EJournalLevel level, EJournalCategory category, const std::string &name, Index indent=0, const std::string &prefix="") const
| Print detailed information about the matrix. More...
virtual void | Print (const Journalist &jnlst, EJournalLevel level, EJournalCategory category, const std::string &name, Index indent=0, const std::string &prefix="") const
Public Member Functions inherited from Ipopt::TaggedObject
| TaggedObject ()
| Constructor. More...
virtual | ~TaggedObject ()
| Destructor. More...
Tag | GetTag () const
| Users of TaggedObjects call this to update their own internal tags every time they perform the expensive operation. More...
bool | HasChanged (const Tag comparison_tag) const
| Users of TaggedObjects call this to check if the object HasChanged since they last updated their own internal tag. More...
Public Member Functions inherited from Ipopt::ReferencedObject
| ReferencedObject ()
virtual | ~ReferencedObject ()
Index | ReferenceCount () const
void | AddRef (const Referencer *referencer) const
void | ReleaseRef (const Referencer *referencer) const
Public Member Functions inherited from Ipopt::Subject
| Subject ()
| Default Constructor. More...
virtual | ~Subject ()
| Default destructor. More...
void | AttachObserver (Observer::NotifyType notify_type, Observer *observer) const
| Attach the specified observer (i.e., begin recieving notifications). More...
void | DetachObserver (Observer::NotifyType notify_type, Observer *observer) const
| Detach the specified observer (i.e., no longer recieve notifications). More...

## Protected Member Functions
Overloaded methods from Matrix base class
virtual void | MultVectorImpl (Number alpha, const Vector &x, Number beta, Vector &y) const
| Matrix-vector multiply. More...
virtual void | TransMultVectorImpl (Number alpha, const Vector &x, Number beta, Vector &y) const
| Matrix(transpose) vector multiply. More...
virtual bool | HasValidNumbersImpl () const
| Method for determining if all stored numbers are valid (i.e., no Inf or Nan). More...
virtual void | ComputeRowAMaxImpl (Vector &rows_norms, bool init) const
| Compute the max-norm of the rows in the matrix. More...
virtual void | ComputeColAMaxImpl (Vector &cols_norms, bool init) const
| Compute the max-norm of the columns in the matrix. More...
virtual void | PrintImpl (const Journalist &jnlst, EJournalLevel level, EJournalCategory category, const std::string &name, Index indent, const std::string &prefix) const
| Print detailed information about the matrix. More...
Protected Member Functions inherited from Ipopt::Matrix
virtual void | AddMSinvZImpl (Number alpha, const Vector &S, const Vector &Z, Vector &X) const
| X = X + alpha*(Matrix S^{-1} Z). More...
virtual void | SinvBlrmZMTdBrImpl (Number alpha, const Vector &S, const Vector &R, const Vector &Z, const Vector &D, Vector &X) const
| X = S^{-1} (r + alpha*Z*M^Td). More...
Protected Member Functions inherited from Ipopt::TaggedObject
void | ObjectChanged ()
| Objects derived from TaggedObject MUST call this method every time their internal state changes to update the internal tag for comparison. More...
Protected Member Functions inherited from Ipopt::Subject
void | Notify (Observer::NotifyType notify_type) const

## Private Member Functions
Default Compiler Generated Methods
(Hidden to avoid implicit creation/calling). These methods are not implemented and we do not want the compiler to implement them for us, so we declare them private and do not define them. This ensures that they will not be implicitly created/called.
| ExpandedMultiVectorMatrix ()
| Default Constructor. More...
| ExpandedMultiVectorMatrix (const ExpandedMultiVectorMatrix &)
| Copy Constructor. More...
void | operator= (const ExpandedMultiVectorMatrix &)
| Overloaded Equals Operator. More...

## Private Attributes
const ExpandedMultiVectorMatrixSpace * | owner_space_
std::vector< SmartPtr< const Vector > > | vecs_
| space for storing the const Vector's More...

## Additional Inherited Members
Public Types inherited from Ipopt::TaggedObject
typedef unsigned int | Tag
| Type for the Tag values. More...

## Detailed Description

Class for Matrices with few rows that consists of Vectors, together with a premultiplied Expansion matrix.

So, the matrix is V^T*P^T. If P is NULL, it is assumed to be the identity matrix. If a row vector of V is NULL, it is assumed to be all zero. This is used to construct the KKT system with low-rank Hessian approximation.

Definition at line 29 of file IpExpandedMultiVectorMatrix.hpp.

## Constructor & Destructor Documentation

Ipopt::ExpandedMultiVectorMatrix::ExpandedMultiVectorMatrix | ( | const ExpandedMultiVectorMatrixSpace * | owner_space | ) |

Constructor, taking the owner_space.

virtual Ipopt::ExpandedMultiVectorMatrix::~ExpandedMultiVectorMatrix | ( |  | ) |
| inline virtual

Destructor.

Definition at line 41 of file IpExpandedMultiVectorMatrix.hpp.

Ipopt::ExpandedMultiVectorMatrix::ExpandedMultiVectorMatrix | ( |  | ) |
| private

Default Constructor.

Ipopt::ExpandedMultiVectorMatrix::ExpandedMultiVectorMatrix | ( | const ExpandedMultiVectorMatrix & |  | ) |
| private

Copy Constructor.

## Member Function Documentation

SmartPtr< ExpandedMultiVectorMatrix > Ipopt::ExpandedMultiVectorMatrix::MakeNewExpandedMultiVectorMatrix | ( |  | ) | const
| inline

Definition at line 170 of file IpExpandedMultiVectorMatrix.hpp.

void Ipopt::ExpandedMultiVectorMatrix::SetVector | ( | Index | i,
|  | SmartPtr< const Vector > | vec
| ) |  |

Set a particular Vector at a given row position, replacing another vector if there has been one.

SmartPtr<const Vector> Ipopt::ExpandedMultiVectorMatrix::GetVector | ( | Index | i | ) | const
| inline

Get a Vector in a particular row as a const Vector.

Definition at line 52 of file IpExpandedMultiVectorMatrix.hpp.

SmartPtr< const VectorSpace > Ipopt::ExpandedMultiVectorMatrix::RowVectorSpace | ( |  | ) | const
| inline

Vector space for the rows.

Definition at line 176 of file IpExpandedMultiVectorMatrix.hpp.

SmartPtr< const ExpandedMultiVectorMatrixSpace > Ipopt::ExpandedMultiVectorMatrix::ExpandedMultiVectorMatrixOwnerSpace | ( |  | ) | const
| inline

Return the ExpandedMultiVectorMatrixSpace.

Definition at line 189 of file IpExpandedMultiVectorMatrix.hpp.

SmartPtr< const ExpansionMatrix > Ipopt::ExpandedMultiVectorMatrix::GetExpansionMatrix | ( |  | ) | const
| inline

Return the Expansion matrix.

If NULL, there is no expansion, the vector is used as is.

Definition at line 182 of file IpExpandedMultiVectorMatrix.hpp.

virtual void Ipopt::ExpandedMultiVectorMatrix::MultVectorImpl | ( | Number | alpha,
|  | const Vector & | x,
|  | Number | beta,
|  | Vector & | y
| ) |  | const
| protected virtual

Matrix-vector multiply.

Computes y = alpha * Matrix * x + beta * y

Implements Ipopt::Matrix.

virtual void Ipopt::ExpandedMultiVectorMatrix::TransMultVectorImpl | ( | Number | alpha,
|  | const Vector & | x,
|  | Number | beta,
|  | Vector & | y
| ) |  | const
| protected virtual

Matrix(transpose) vector multiply.

Computes y = alpha * Matrix^T * x + beta * y

Implements Ipopt::Matrix.

virtual bool Ipopt::ExpandedMultiVectorMatrix::HasValidNumbersImpl | ( |  | ) | const
| protected virtual

Method for determining if all stored numbers are valid (i.e., no Inf or Nan).

Reimplemented from Ipopt::Matrix.

virtual void Ipopt::ExpandedMultiVectorMatrix::ComputeRowAMaxImpl | ( | Vector & | rows_norms,
|  | bool | init
| ) |  | const
| protected virtual

Compute the max-norm of the rows in the matrix.

The result is stored in rows_norms. The vector is assumed to be initialized.

Implements Ipopt::Matrix.

virtual void Ipopt::ExpandedMultiVectorMatrix::ComputeColAMaxImpl | ( | Vector & | cols_norms,
|  | bool | init
| ) |  | const
| protected virtual

Compute the max-norm of the columns in the matrix.

The result is stored in cols_norms. The vector is assumed to be initialized.

Implements Ipopt::Matrix.

virtual void Ipopt::ExpandedMultiVectorMatrix::PrintImpl | ( | const Journalist & | jnlst,
|  | EJournalLevel | level,
|  | EJournalCategory | category,
|  | const std::string & | name,
|  | Index | indent,
|  | const std::string & | prefix
| ) |  | const
| protected virtual

Print detailed information about the matrix.

Implements Ipopt::Matrix.

void Ipopt::ExpandedMultiVectorMatrix::operator= | ( | const ExpandedMultiVectorMatrix & |  | ) |
| private

Overloaded Equals Operator.

## Member Data Documentation

const ExpandedMultiVectorMatrixSpace* Ipopt::ExpandedMultiVectorMatrix::owner_space_
| private

Definition at line 114 of file IpExpandedMultiVectorMatrix.hpp.

std::vector<SmartPtr<const Vector> > Ipopt::ExpandedMultiVectorMatrix::vecs_
| private

space for storing the const Vector's

Definition at line 117 of file IpExpandedMultiVectorMatrix.hpp.

The documentation for this class was generated from the following file:

- src/LinAlg/IpExpandedMultiVectorMatrix.hpp